<template>
  <div>
    <!-- Project Slug -->
    <CoscineFormGroup
      label-for="ProjectSlug"
      :label="$t('form.project.projectSlugLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="ProjectSlug"
        v-model="projectForm.slug"
        :readonly="readonly"
        :disabled="readonly"
        required
      />
    </CoscineFormGroup>

    <!-- Project Persistent Identifier -->
    <CoscineFormGroup
      label-for="ProjectPersistentId"
      :label="$t('form.project.projectPersistentIdLabel')"
      :is-loading="isLoading"
      info
    >
      <template #popover>
        {{ $t("form.project.projectPersistentIdPopover") }}
        <b-link
          :href="$t('form.project.projectPersistentIdPopoverUrl').toString()"
          target="_blank"
        >
          {{ $t("default.help") }}
        </b-link>
      </template>

      <b-button-group class="w-100">
        <!-- Text Field -->
        <b-form-input
          id="ProjectPersistentId"
          v-model="projectForm.pid"
          required
          :readonly="readonly"
          :disabled="readonly"
        />

        <!-- Copy Button -->
        <b-button
          id="copyPidButton"
          v-b-tooltip.click.top="
            $t('form.project.toClipboard', {
              projectOption: $t('form.project.projectPersistentId'),
            })
          "
          @click="copyPid"
        >
          <i-bi-clipboard />
        </b-button>
      </b-button-group>
    </CoscineFormGroup>
  </div>
</template>

<script lang="ts">
import type { ProjectDto } from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  props: {
    modelValue: {
      type: Object as PropType<ProjectDto>,
      required: true,
    },
    isLoading: {
      default: false,
      type: Boolean,
    },
  },

  data() {
    return {
      readonly: true,
      projectForm: this.modelValue,
    };
  },
  methods: {
    copyPid() {
      if (this.projectForm) {
        navigator.clipboard.writeText(
          "http://hdl.handle.net/" + this.projectForm.pid,
        );
      }
    },
  },
});
</script>
